; TIP1167A.LSP: EXT.LSP   Enhanced Zooms   (c)1995, Tom Beauford

; If drawing extents have been reduced then "zoom" "e"
;   is required. 
(defun C:EXT ( / MIN MAX SEL ZCENTER ZX ZY TOM HEIGHT )
  (if (= MAR nil) (setq MAR 4))
  (setq MIN (getvar "EXTMIN") MAX (getvar "EXTMAX")
    ZCENTER
    (list
      (+(car  MIN) (/(-(car  MAX) (car  MIN)) 2))
      (+(cadr MIN) (/(-(cadr MAX) (cadr MIN)) 2))
    )
    ZX
    (abs (*(/(cadr (getvar "SCREENSIZE"))
        (car (getvar "SCREENSIZE")))
        (-(car MAX) (car MIN))
      )
    )
    ZY (abs (-(cadr MAX) (cadr MIN)))
    TOM (getvar "USERR3")
  )
  (setvar "USERR3" MAR)
  (princ "\nPercent of screen to use as margin:<")
  (princ MAR)
  (princ ">")
  (command "setvar" "userr3" pause) MAR
  (setq MAR (getvar "userr3"))
  (setvar "userr3" TOM)
  (if (<= ZY ZX)
    (setq HEIGHT (*(+(/ MAR 100.0)1)ZX))
    (setq HEIGHT (*(+(/ MAR 100.0)1)ZY))
  )
  (command "zoom" "c" ZCENTER HEIGHT)
  (princ "\n\nMargin set at ")
  (princ MAR)
  (princ "%")
  (princ)
); end extents.lsp
