; TIP1169.LSP: TE.LSP   Toggle Extension Lines   (c)1995, Donald L. Levine

;; TE.LSP will Toggle Extension lines simply by picking the dimension
;; several times until the desired result is achieved.  You can toggle
;; as many as you want without exiting the command.  Use the enter button
;; to quit.

(defun cler (VAL) 
  (if (/= VAL "Function cancelled")     ; In case of an error
    (princ (strcat "\nError: " VAL))    ; while this command is active...
  ) 
  (setvar "DIMSE1" EL1)
  (setvar "DIMSE2" EL2)
  (command "_.UNDO" "_end") 
  (setq *error* OLDERR)               ; Restore old *error* handler
  (princ)                             
) 

(defun conv1 (EL1)
  (if (= (Getvar "DIMSE1") 1) (setvar "DIMSE1" 0) (setvar "DIMSE1" 1))
)

(defun conv2 (EL2)
  (if (= (Getvar "DIMSE2") 1) (setvar "DIMSE2" 0) (setvar "DIMSE2" 1))
)

;;; --------------------------- Main Program ---------------------------------;
(DEFUN C:TE (/ EL1 EL2 ENT) 
  (setq OLDERR *error* 
  *error* CLER)
  (COMMAND "_.UNDO" "_GROUP")
  (setq EL1 (getvar "DIMSE1"))
  (setq EL2 (getvar "DIMSE2"))
  (setq ENT nil)
  (setq ENT (entsel))
  (while ENT
    (if ENT
      (progn
        (conv1 EL1)
        (command "dim" "upd" ENT "" "e")
        (setq ENT (entsel))
        (if ENT
          (progn
            (conv1 EL1)
            (conv2 EL2)
            (command "dim" "upd" ENT "" "e")
            (setq ENT (entsel))
            (if ENT
              (progn
                (conv1 EL1)
                (command "dim" "upd" ENT "" "e")
                (setq ENT (entsel))
                (if ENT
                  (progn
                    (conv1 EL1)
                    (conv2 EL2)
                    (command "dim" "upd" ENT "" "e")
                    (setq ENT (entsel))
                  )
                )
              )  
            ) 
          ) 
        ) 
      )
    )
  )
  (setvar "DIMSE1" EL1)
  (setvar "DIMSE2" EL2)
  (setq *error* OLDERR)               ; Restore old *error* handler
  (command "_.UNDO" "_end") 
  (prin1)
); end te.lsp
